<script setup lang="ts">
    import { useRoute } from 'vue-router'
    import { onBeforeMount, provide, ref, watch } from 'vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { logisticServiceOfferInjectionKey } from '../constants'
    import { LogisticServiceOfferApi } from '../entities/logisticServiceOffer/LogisticServiceOfferApi'
    import { LogisticServiceOffer } from '../entities/logisticServiceOffer/LogisticServiceOffer'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const route = useRoute()
    const serviceOfferId = <string>route.params.serviceOfferId

    const logisticServiceOfferApi = new LogisticServiceOfferApi(msal)

    const logisticServiceOffer = ref<LogisticServiceOffer | undefined>()

    provide(logisticServiceOfferInjectionKey, logisticServiceOffer)

    onBeforeMount(() => {
        watch(
            [() => msal.accounts, () => userStore.isImpersonating],
            () => {
                logisticServiceOfferApi
                    .get(serviceOfferId)
                    .then((fetchedLogisticServiceOffer) => {
                        logisticServiceOffer.value = fetchedLogisticServiceOffer
                    })
            },
            { immediate: true }
        )
    })
</script>
<template>
    <router-view :key="$route.fullPath"></router-view>
</template>
